Debian Bug report logs - #691754
kfreebsd-amd64 fails to install on LSI MegaRAID SAS 2208

version graph

Package: kfreebsd-9; Maintainer for kfreebsd-9 is GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>;

Reported by: Tiziano Zito <opossumnano@gmail.com>

Date: Wed, 24 Oct 2012 14:54:02 UTC

Severity: important

Tags: d-i

Merged with 691346

Fixed in version 9.1

Done: Robert Millan <rmh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, opossumnano@gmail.com, Debian Install Team <debian-boot@lists.debian.org>:
Bug#691346; Package installation-reports. (Wed, 24 Oct 2012 14:54:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tiziano Zito <opossumnano@gmail.com>:
New Bug report received and forwarded. Copy sent to opossumnano@gmail.com, Debian Install Team <debian-boot@lists.debian.org>. (Wed, 24 Oct 2012 14:54:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Tiziano Zito <opossumnano@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: kfreebsd-amd64 fails to install on LSI MegaRAID SAS 2208
Date: Wed, 24 Oct 2012 16:50:45 +0200
[Message part 1 (text/plain, inline)]
Package: installation-reports
Severity: critical
Tags: d-i

-- Package-specific info:

Boot method: CD
Image version: debian-wheezy-DI-b3-kfreebsd-amd64-netinst.iso
Date: 201210241200

Machine: IBM System x3650 M4
Partitions: no partitions

Base System Installation Checklist:
[O] = OK, [E] = Error (please elaborate below), [ ] = didn't try it

Initial boot:           [E]
Detect network card:    [ ]
Configure network:      [ ]
Detect CD:              [ ]
Load installer modules: [ ]
Clock/timezone setup:   [ ]
User/password setup:    [ ]
Detect hard drives:     [ ]
Partition hard drives:  [ ]
Install base system:    [ ]
Install tasks:          [ ]
Install boot loader:    [ ]
Overall install:        [ ]

Comments/Problems:

On this server the LSI RAID controller LSI MegaRAID SAS 2208/ServeRAID M5110e
is installed. I tried installing kfreebsd-amd64 on it from CD. The
installer GRUB menu works (see attachment boot.png), but right after
that the FreeBSD kernel hangs during boot with an error (see
attachment error.png). After 10/20 seconds another error line gets
printed -- something about hard resetting something -- but it was
too fast for me to take a screenshot, and the system reboots. 
On the very same machine I was able to install the standard 
debian-wheezy-DI-b3-amd64-netinst.iso without any problem. 

On LSI website I found this:
http://kb.lsi.com/KnowledgebaseArticle16687.aspx
which seems to indicate that FreeBSD 9.0 ships an obsolete kernel
module for this controller, and they suggest a procedure how to create
a FreeBSD 9.0 installer with an updated module. My knowledge of
FreeBSD are a bit too limited for me to seriously think about
recompile the kernel and injecting some additional modules, but
maybe someone in the kfreebsd debian team knows how to do it?

I now have the machine up and running with linux debian amd64, so I
can make any needed additional hardware info -- as linux sees it --
available. I can also make the remote control console accessible to
more knowledgeable people for debugging.

Thanks,
Tiziano

PS: I did not know what severity to set, I thought that complete
install failures qualifies for "critical", but please downgrade it
if needed.
[boot.png (image/png, attachment)]
[error.png (image/png, attachment)]

Bug 691346 cloned as bug 691754 Request was from Tiziano Zito <opossumnano@gmail.com> to control@bugs.debian.org. (Mon, 29 Oct 2012 12:09:14 GMT) Full text and rfc822 format available.

Bug reassigned from package 'installation-reports' to 'kfreebsd-9'. Request was from Tiziano Zito <opossumnano@gmail.com> to control@bugs.debian.org. (Mon, 29 Oct 2012 12:09:14 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#691754; Package kfreebsd-9. (Wed, 31 Oct 2012 18:09:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Christoph Egger <christoph@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 31 Oct 2012 18:09:06 GMT) Full text and rfc822 format available.

Message #14 received at 691754@bugs.debian.org (full text, mbox):

From: Christoph Egger <christoph@debian.org>
To: 691754@bugs.debian.org, opossumnano@gmail.com
Subject: LSI MegaRAID
Date: Wed, 31 Oct 2012 11:05:15 -0700
Control: severity -1 important

Hi!

  Considering this seems to affect a very limited number of hardware I
don't think it actually classifies as critical for kfreebsd after
all. Nonetheless it might be good to fix the problem -- if
possible. Unfortunately the linked documentation does not give any
technical insight into the problem. Is the problem already fixed in the
development branch of FreeBSD for example? At least if we can find a
small-ish correct patch we should add that to outr kfreebsd-9 kernel.

Regards

    Christoph



Severity set to 'important' from 'critical' Request was from Christoph Egger <christoph@debian.org> to 691754-submit@bugs.debian.org. (Wed, 31 Oct 2012 18:09:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#691754; Package kfreebsd-9. (Wed, 31 Oct 2012 19:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 31 Oct 2012 19:45:05 GMT) Full text and rfc822 format available.

Message #21 received at 691754@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: 691754@bugs.debian.org
Cc: "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>, opossumnano@gmail.com
Subject: Re: Bug#691754: LSI MegaRAID
Date: Wed, 31 Oct 2012 19:43:16 +0000
I wonder why the kernel output mentions "mpt0:" rather than "mpslsi0:";
 it should be using the mps(4) driver for this card:

http://www.freebsd.org/cgi/man.cgi?query=mps

Anyway the man page says this driver was still in development.  Even if
some small fix exists for this particular issue at boot, it still might
not be stable.

However, FreeBSD 9.0-stable ships a newer driver from LSI (maybe it's
the same as the new mrsas driver mentioned in LSI's KB article?).

http://svnweb.freebsd.org/base/stable/9/sys/dev/mps/mps.c?view=log

I guess this driver is being used with FreeBSD at Netflix (they claim to
use MPT2 controllers for their new CDN) and/or at Yahoo!;  note that
scottl reviewed many of the fixes in the changelog:

http://lists.freebsd.org/pipermail/freebsd-stable/2012-June/068129.html

That suggests it would be technically possible to use the newer driver
with kFreeBSD 9.0, but the diff would be large, and maybe not the sort
of thing that could be introduced this late in the freeze for Wheezy?

After Wheezy is released we may be able to get the new mps(4) driver
into a point release, and/or at least get FreeBSD 9.1 into wheezy-backports,

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#691754; Package kfreebsd-9. (Wed, 31 Oct 2012 19:51:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 31 Oct 2012 19:51:12 GMT) Full text and rfc822 format available.

Message #26 received at 691754@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: 691754@bugs.debian.org
Cc: "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>, opossumnano@gmail.com
Subject: Re: Bug#691754: LSI MegaRAID
Date: Wed, 31 Oct 2012 19:49:34 +0000
Actually this is the more relevant changelog;  it can be seen that 9.1
will definitely have the new driver from LSI:

http://svnweb.freebsd.org/base/releng/9.1/sys/dev/mps/mps.c?view=log

Also I'm not completely sure the mps(4) driver can be backported to
kFreeBSD 9.0.  I think getting kFreeBSD 9.1 into wheezy-backports very
soon after Wheezy is released would be the best plan.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#691754; Package kfreebsd-9. (Thu, 01 Nov 2012 09:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tiziano Zito <opossumnano@gmail.com>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Thu, 01 Nov 2012 09:36:04 GMT) Full text and rfc822 format available.

Message #31 received at 691754@bugs.debian.org (full text, mbox):

From: Tiziano Zito <opossumnano@gmail.com>
To: Christoph Egger <christoph@debian.org>, Steven Chamberlain <steven@pyro.eu.org>
Cc: 691754@bugs.debian.org, "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: LSI MegaRAID
Date: Thu, 1 Nov 2012 10:24:26 +0100
Hi!

> Considering this seems to affect a very limited number of hardware I
> don't think it actually classifies as critical for kfreebsd after
> all.

I don't know how many SystemX servers IBM has sold in the last 6
months, but most of them mount this or other LSI cards based on the
same LSI MegaRAID SAS 2208 chip. So it may be a quite significant
amount of hardware...

> However, FreeBSD 9.0-stable ships a newer driver from LSI (maybe it's
> the same as the new mrsas driver mentioned in LSI's KB article?).
> 
> http://svnweb.freebsd.org/base/stable/9/sys/dev/mps/mps.c?view=log
> 
> I guess this driver is being used with FreeBSD at Netflix (they claim to
> use MPT2 controllers for their new CDN) and/or at Yahoo!;  note that
> scottl reviewed many of the fixes in the changelog:
> 
> http://lists.freebsd.org/pipermail/freebsd-stable/2012-June/068129.html
> 
> That suggests it would be technically possible to use the newer driver
> with kFreeBSD 9.0, but the diff would be large, and maybe not the sort
> of thing that could be introduced this late in the freeze for Wheezy?

I can not confirm that those are the same drivers. Comparing the
sources of the drivers shipped by LSI with that:

> http://svnweb.freebsd.org/base/releng/9.1/sys/dev/mps/mps.c?view=log

seems to indicate that they don't have anything to do with each
other. Maybe same chip but different card with different API? Or
maybe just a lot of refactoring... no idea.

Anyway, I managed to successfully install FreeBSD-9.0-RELEASE
following the instructions here (pages 26-35):
http://www.lsi.com/downloads/Public/MegaRAID%20Common%20Files/80-00163-01_RevG.pdf

The sources and the pre-compiled module can be found here:
http://www.lsi.com/downloads/Public/MegaRAID%20Common%20Files/MR_FreeBSD_DRIVER_2208-v05.504.05.00.tgz

As I was installing a stock kernel, for me it boiled down to just
copying the pre-compiled module mrsas.ko to /boot/kernel and add the following
two lines to /boot/loader.conf:
mfi_load="NO"
mrsas_load="YES"

So, all in all, for kfreebsd it would be a patch of 5524 lines, but
all concentrated in a single directory for a module that was not
present in kfreebsd before, so the probability of breaking something
else along the way seems pretty small. And, the module sources are
BSD licensed, so no problems with that either ;)

Ciao,
Tiziano




Merged 691346 691754 Request was from Robert Millan <rmh@debian.org> to control@bugs.debian.org. (Wed, 15 Jan 2014 11:12:09 GMT) Full text and rfc822 format available.

Message #34 received at 691346-done@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Tiziano Zito <opossumnano@gmail.com>, 691346-done@bugs.debian.org
Cc: Mathieu Simon <mathieu.sim@gmail.com>
Subject: Re: Bug#691346: mfi in 9.1
Date: Mon, 20 Jan 2014 16:12:19 +0100
Version: 9.1

On 20/01/2014 10:51, Tiziano Zito wrote:
> On Wed 15 Jan, 11:12, Robert Millan <rmh@debian.org> wrote:
>> On Mon, Nov 12, 2012 at 01:56:38PM +0100, Mathieu Simon wrote:
>>> G'day
>>>
>>> Actually FreBSD 9.1 will contain update 'mfi' driver code which
>>> largely expands the support for MegaRAID drivers. (confirmed witha
>>> 9.1-RC3 media)
>>> It might be interesting for you to boo a native FreeBSD ISO of
>>> this version to see if your controller is recognized by this mfi module.
>>> (use "pciconf -lvb | grep mfi" and "mfiutil show adapter" to check)
>>
>> Tiziano, did you try with 9.1 kernel as suggested? Actually, you could
>> try 10.0~rc from unstable, it might give better results.
>>
>> Please let us know if it works for you.
> 
> Hi, 
> 
> sorry for not following up on this sooner. Last year I decided to go
> the FreeBSD route and updated the kernel module as specified on the
> LSI website. It worked fine.
> The upgrade to 9.1 brought the new mfi module, which indeed supports
> the controller, so from kernel 9.1 onwards there is no need to
> compile any additional module. 
> 
> The server is now running a 9.2-RELEASE kernel and everything works
> fine. As the server is in production I can not really test a
> Debian+kfreebsd installation, but I have no reason to think that it
> would make any difference, so for me the bug can be closed :)

Excellent! Thank you.

-- 
Robert Millan



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 27 Feb 2014 07:28:58 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 00:11:31 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.